︠42ad1279-bc5a-438f-a0fc-b0218d572cb5i︠
%md
## Interact: Sage's analogue of Mathematica's manipulate...

Take any Python function and put `@interact` in the line before it, and it becomes interactive.
︡ef69f92b-00ff-4656-9fe4-afa3ecc04b83︡{"done":true,"md":"## Interact: Sage's analogue of Mathematica's manipulate...\n\nTake any Python function and put `@interact` in the line before it, and it becomes interactive."}
︠8293af77-9307-4d8b-ab98-c23eac71f9ccs︠
def g(n, m):
    print n, "×", m, "=", n*m
︡599931e3-98aa-4afa-99d0-a686e58befd3︡{"done":true}︡
︠5efbf044-7188-4f41-ac0d-9cdbb28188acs︠
g(5,3)
︡12e694d2-9ff3-430d-a816-a10caf5b4519︡{"stdout":"5 × 3 = 15\n"}︡{"done":true}︡
︠ba4b1463-aeda-4756-8e3a-6e8fa900b885i︠
%md
Now, let's make it interactive

- expect errors until you fill in values for n and m below!
︡d92fcde6-70a8-4ae1-9508-57731605206e︡{"done":true,"md":"Now, let's make it interactive\n\n- expect errors until you fill in values for n and m below!"}
︠b494ee91-7534-4319-8790-8547786760b5s︠
@interact
def g(n, m):
    print n, "×", m, "=", n*m
︡958c0f59-ed12-4c56-a9e9-e226a9f5b127︡{"interact":{"controls":[{"control_type":"input-box","default":null,"label":"n","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"n","width":null},{"control_type":"input-box","default":null,"label":"m","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"m","width":null}],"flicker":false,"id":"d3ced83f-767b-4d1b-8a61-8694119e152e","layout":[[["n",12,null]],[["m",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠b03620d0-e1e0-4f51-8a29-2b38979497cfs︠
# this time give default values:
@interact
def g(n=4, m=7):
    print n, "×", m, "=", n*m
︡0b2ffc26-174a-41dc-bb1b-0e598c33a541︡{"interact":{"controls":[{"control_type":"input-box","default":4,"label":"n","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"n","width":null},{"control_type":"input-box","default":7,"label":"m","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"m","width":null}],"flicker":false,"id":"eb6ce57b-9e52-4eae-902d-95d3d033d031","layout":[[["n",12,null]],[["m",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠e64c50db-5ed7-4c0f-83fd-d33e3242f2a8s︠
pi + e +e
︡7df79c48-8a3e-485f-9df9-9a3991786684︡{"stdout":"pi + 2*e\n"}︡{"done":true}︡
︠d4e421fd-5b98-47a7-8213-6826f66b1a71s︠
N(pi + e +e, digits=100)
︡9f8e92d3-617e-41d5-ae60-1557222e5d95︡{"stdout":"8.578156310507883709183218325984827879711663586775024970908879847755969666993304187770799182392449923\n"}︡{"done":true}︡
︠b941fbc9-0681-4724-a1b7-44202f2da515s︠

# this time give specific values:
@interact
def g(n=(0,pi/2,..12), m=(0,pi,..,12)):
    print n, "×", m, "=", n*m
︡53ac0ac9-454c-4877-9080-cc9120acbb3a︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["0","1/2*pi","pi","3/2*pi","2*pi","5/2*pi","3*pi","7/2*pi"],"var":"n","width":null},{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"m","vals":["0","pi","2*pi","3*pi"],"var":"m","width":null}],"flicker":false,"id":"a7ab7d04-a275-4207-a9cf-7a3aea31d017","layout":[[["n",12,null]],[["m",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠20cf6a4c-2e49-41cb-bcb1-aa9ac712967as︠
# this time give specific values *and* specify the operation.
@interact
def g(n=(1..12), m=(1..12), operation=['multiply', 'add']):
    if operation == 'multiply':
        print n, "×", m, "=", n*m
    else:
        print n, "+", m, "=", n+m
︡c4acd487-0f7c-4fea-9152-6b0c0e514fd8︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["1","2","3","4","5","6","7","8","9","10","11","12"],"var":"n","width":null},{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"m","vals":["1","2","3","4","5","6","7","8","9","10","11","12"],"var":"m","width":null},{"button_classes":null,"buttons":true,"control_type":"selector","default":0,"label":"operation","lbls":["multiply","add"],"ncols":null,"nrows":null,"var":"operation","width":null}],"flicker":false,"id":"a837806f-61a2-46ca-bb6f-ae69b5895773","layout":[[["n",12,null]],[["m",12,null]],[["operation",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠ec85d175-eced-4bc3-9fba-27bd076841cbi︠
%md
As you're starting to see, you can make these interacts very sophisticated.

- There are tons of examples [here](https://wiki.sagemath.org/interact)

- You can also make them publicly available (no login/account required) at [the sagecell server](http://sagecell.sagemath.org/), and those can be [embedded in any random website](https://www.bookofproofs.org/branches/the-gaussian-method-in-practice/).
︡d430ec15-a6d3-40f1-b648-bbfe7ffb6196︡{"done":true,"md":"As you're starting to see, you can make these interacts very sophisticated.\n\n- There are tons of examples [here](https://wiki.sagemath.org/interact)\n\n- You can also make them publicly available (no login/account required) at [the sagecell server](http://sagecell.sagemath.org/), and those can be [embedded in any random website](https://www.bookofproofs.org/branches/the-gaussian-method-in-practice/)."}
︠e68c0cf2-4dcf-4675-9af9-61669b9e6d75s︠

var('x,y,t,z')
f(x,y)=sin(x)*cos(y)

pif = float(pi)

line_thickness=3
surface_color='blue'
plane_color='purple'
line_color='red'
tangent_color='green'
gradient_color='orange'

@interact
def myfun(location=input_grid(1, 2, default=[0,0], label = "Location (x,y)", width=2), angle=slider(0, 2*pif, label = "Angle"), 
show_surface=("Show surface", True)):
    location3d = vector(location[0]+[0])
    location = location3d[0:2]
    direction3d = vector(RDF, [cos(angle), sin(angle), 0])
    direction=direction3d[0:2]
    cos_angle = math.cos(angle)
    sin_angle = math.sin(angle)
    df = f.gradient()
    direction_vector=line3d([location3d, location3d+direction3d], arrow_head=True, rgbcolor=line_color, thickness=line_thickness)
    curve_point = (location+t*direction).list()
    curve = parametric_plot(curve_point+[f(*curve_point)], (t,-3,3),color=line_color,thickness=line_thickness)
    plane = parametric_plot((cos_angle*x+location[0],sin_angle*x+location[1],t), (x, -3,3), (t,-3,3),opacity=0.8, color=plane_color)
    pt = point3d(location3d.list(),color='green', size=10)

    tangent_line = parametric_plot((location[0]+t*cos_angle, location[1]+t*sin_angle, f(*location)+t*df(*location)*(direction)), (t, -3,3), thickness=line_thickness, color=tangent_color)
    picture3d = direction_vector+curve+plane+pt+tangent_line

    picture2d = contour_plot(f(x,y), (x,-3,3),(y,-3,3), plot_points=100)
    picture2d += arrow(location.list(), (location+direction).list()) 
    picture2d += point(location.list(),rgbcolor='green',pointsize=40)
    if show_surface:
        picture3d += plot3d(f, (x,-3,3),(y,-3,3),opacity=0.7)
        
    dff = df(location[0], location[1])
    dff3d = vector(RDF,dff.list()+[0])
    picture3d += line3d([location3d, location3d+dff3d], arrow_head=True, rgbcolor=gradient_color, thickness=line_thickness)
    picture2d += arrow(location.list(), (location+dff).list(), rgbcolor=gradient_color, width=line_thickness)
    show(picture3d,aspect_ratio=[1,1,1])
    show(picture2d, aspect_ratio=1)
︡a7128c6d-44dc-45ee-a3bb-c0560965b75b︡{"stdout":"(x, y, t, z)\n"}︡{"interact":{"controls":[{"control_type":"input-grid","default":[["0","0"]],"label":"Location (x,y)","ncols":2,"nrows":1,"var":"location","width":2},{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"Angle","vals":["0.0","0.0125663706144","0.0251327412287","0.0376991118431","0.0502654824574","0.0628318530718","0.0753982236862","0.0879645943005","0.100530964915","0.113097335529","0.125663706144","0.138230076758","0.150796447372","0.163362817987","0.175929188601","0.188495559215","0.20106192983","0.213628300444","0.226194671058","0.238761041673","0.251327412287","0.263893782902","0.276460153516","0.28902652413","0.301592894745","0.314159265359","0.326725635973","0.339292006588","0.351858377202","0.364424747816","0.376991118431","0.389557489045","0.402123859659","0.414690230274","0.427256600888","0.439822971503","0.452389342117","0.464955712731","0.477522083346","0.49008845396","0.502654824574","0.515221195189","0.527787565803","0.540353936417","0.552920307032","0.565486677646","0.578053048261","0.590619418875","0.603185789489","0.615752160104","0.628318530718","0.640884901332","0.653451271947","0.666017642561","0.678584013175","0.69115038379","0.703716754404","0.716283125018","0.728849495633","0.741415866247","0.753982236862","0.766548607476","0.77911497809","0.791681348705","0.804247719319","0.816814089933","0.829380460548","0.841946831162","0.854513201776","0.867079572391","0.879645943005","0.89221231362","0.904778684234","0.917345054848","0.929911425463","0.942477796077","0.955044166691","0.967610537306","0.98017690792","0.992743278534","1.00530964915","1.01787601976","1.03044239038","1.04300876099","1.05557513161","1.06814150222","1.08070787283","1.09327424345","1.10584061406","1.11840698468","1.13097335529","1.14353972591","1.15610609652","1.16867246714","1.18123883775","1.19380520836","1.20637157898","1.21893794959","1.23150432021","1.24407069082","1.25663706144","1.26920343205","1.28176980266","1.29433617328","1.30690254389","1.31946891451","1.33203528512","1.34460165574","1.35716802635","1.36973439697","1.38230076758","1.39486713819","1.40743350881","1.41999987942","1.43256625004","1.44513262065","1.45769899127","1.47026536188","1.48283173249","1.49539810311","1.50796447372","1.52053084434","1.53309721495","1.54566358557","1.55822995618","1.57079632679","1.58336269741","1.59592906802","1.60849543864","1.62106180925","1.63362817987","1.64619455048","1.6587609211","1.67132729171","1.68389366232","1.69646003294","1.70902640355","1.72159277417","1.73415914478","1.7467255154","1.75929188601","1.77185825662","1.78442462724","1.79699099785","1.80955736847","1.82212373908","1.8346901097","1.84725648031","1.85982285093","1.87238922154","1.88495559215","1.89752196277","1.91008833338","1.922654704","1.93522107461","1.94778744523","1.96035381584","1.97292018645","1.98548655707","1.99805292768","2.0106192983","2.02318566891","2.03575203953","2.04831841014","2.06088478075","2.07345115137","2.08601752198","2.0985838926","2.11115026321","2.12371663383","2.13628300444","2.14884937506","2.16141574567","2.17398211628","2.1865484869","2.19911485751","2.21168122813","2.22424759874","2.23681396936","2.24938033997","2.26194671058","2.2745130812","2.28707945181","2.29964582243","2.31221219304","2.32477856366","2.33734493427","2.34991130489","2.3624776755","2.37504404611","2.38761041673","2.40017678734","2.41274315796","2.42530952857","2.43787589919","2.4504422698","2.46300864041","2.47557501103","2.48814138164","2.50070775226","2.51327412287","2.52584049349","2.5384068641","2.55097323471","2.56353960533","2.57610597594","2.58867234656","2.60123871717","2.61380508779","2.6263714584","2.63893782902","2.65150419963","2.66407057024","2.67663694086","2.68920331147","2.70176968209","2.7143360527","2.72690242332","2.73946879393","2.75203516454","2.76460153516","2.77716790577","2.78973427639","2.802300647","2.81486701762","2.82743338823","2.83999975885","2.85256612946","2.86513250007","2.87769887069","2.8902652413","2.90283161192","2.91539798253","2.92796435315","2.94053072376","2.95309709437","2.96566346499","2.9782298356","2.99079620622","3.00336257683","3.01592894745","3.02849531806","3.04106168867","3.05362805929","3.0661944299","3.07876080052","3.09132717113","3.10389354175","3.11645991236","3.12902628298","3.14159265359","3.1541590242","3.16672539482","3.17929176543","3.19185813605","3.20442450666","3.21699087728","3.22955724789","3.2421236185","3.25468998912","3.26725635973","3.27982273035","3.29238910096","3.30495547158","3.31752184219","3.33008821281","3.34265458342","3.35522095403","3.36778732465","3.38035369526","3.39292006588","3.40548643649","3.41805280711","3.43061917772","3.44318554833","3.45575191895","3.46831828956","3.48088466018","3.49345103079","3.50601740141","3.51858377202","3.53115014263","3.54371651325","3.55628288386","3.56884925448","3.58141562509","3.59398199571","3.60654836632","3.61911473694","3.63168110755","3.64424747816","3.65681384878","3.66938021939","3.68194659001","3.69451296062","3.70707933124","3.71964570185","3.73221207246","3.74477844308","3.75734481369","3.76991118431","3.78247755492","3.79504392554","3.80761029615","3.82017666677","3.83274303738","3.84530940799","3.85787577861","3.87044214922","3.88300851984","3.89557489045","3.90814126107","3.92070763168","3.93327400229","3.94584037291","3.95840674352","3.97097311414","3.98353948475","3.99610585537","4.00867222598","4.02123859659","4.03380496721","4.04637133782","4.05893770844","4.07150407905","4.08407044967","4.09663682028","4.1092031909","4.12176956151","4.13433593212","4.14690230274","4.15946867335","4.17203504397","4.18460141458","4.1971677852","4.20973415581","4.22230052642","4.23486689704","4.24743326765","4.25999963827","4.27256600888","4.2851323795","4.29769875011","4.31026512073","4.32283149134","4.33539786195","4.34796423257","4.36053060318","4.3730969738","4.38566334441","4.39822971503","4.41079608564","4.42336245625","4.43592882687","4.44849519748","4.4610615681","4.47362793871","4.48619430933","4.49876067994","4.51132705055","4.52389342117","4.53645979178","4.5490261624","4.56159253301","4.57415890363","4.58672527424","4.59929164486","4.61185801547","4.62442438608","4.6369907567","4.64955712731","4.66212349793","4.67468986854","4.68725623916","4.69982260977","4.71238898038","4.724955351","4.73752172161","4.75008809223","4.76265446284","4.77522083346","4.78778720407","4.80035357469","4.8129199453","4.82548631591","4.83805268653","4.85061905714","4.86318542776","4.87575179837","4.88831816899","4.9008845396","4.91345091021","4.92601728083","4.93858365144","4.95115002206","4.96371639267","4.97628276329","4.9888491339","5.00141550451","5.01398187513","5.02654824574","5.03911461636","5.05168098697","5.06424735759","5.0768137282","5.08938009882","5.10194646943","5.11451284004","5.12707921066","5.13964558127","5.15221195189","5.1647783225","5.17734469312","5.18991106373","5.20247743434","5.21504380496","5.22761017557","5.24017654619","5.2527429168","5.26530928742","5.27787565803","5.29044202865","5.30300839926","5.31557476987","5.32814114049","5.3407075111","5.35327388172","5.36584025233","5.37840662295","5.39097299356","5.40353936417","5.41610573479","5.4286721054","5.44123847602","5.45380484663","5.46637121725","5.47893758786","5.49150395847","5.50407032909","5.5166366997","5.52920307032","5.54176944093","5.55433581155","5.56690218216","5.57946855278","5.59203492339","5.604601294","5.61716766462","5.62973403523","5.64230040585","5.65486677646","5.66743314708","5.67999951769","5.6925658883","5.70513225892","5.71769862953","5.73026500015","5.74283137076","5.75539774138","5.76796411199","5.78053048261","5.79309685322","5.80566322383","5.81822959445","5.83079596506","5.84336233568","5.85592870629","5.86849507691","5.88106144752","5.89362781813","5.90619418875","5.91876055936","5.93132692998","5.94389330059","5.95645967121","5.96902604182","5.98159241244","5.99415878305","6.00672515366","6.01929152428","6.03185789489","6.04442426551","6.05699063612","6.06955700674","6.08212337735","6.09468974796","6.10725611858","6.11982248919","6.13238885981","6.14495523042","6.15752160104","6.17008797165","6.18265434226","6.19522071288","6.20778708349","6.22035345411","6.23291982472","6.24548619534","6.25805256595","6.27061893657","6.28318530718"],"var":"angle","width":null},{"control_type":"checkbox","default":true,"label":"Show surface","readonly":false,"var":"show_surface"}],"flicker":false,"id":"998954f3-2eb8-4c0a-a2e6-565d337f7c0f","layout":[[["location",12,null]],[["angle",12,null]],[["show_surface",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠f6cb0fce-317f-4774-8154-0aad79a51affs︠
interact?
︡d0ba0114-e8f0-40f3-beaa-01bae3617473︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\nSignature : interact(self, f=None, layout=None, width=None, style=None, update_args=None, auto_update=True, flicker=False, output=True)\nDocstring :\nUse interact to create interactive worksheet cells with sliders,\ntext boxes, radio buttons, check boxes, color selectors, and more.\n\nPut \"@interact\" on the line before a function definition in a cell\nby itself, and choose appropriate defaults for the variable names\nto determine the types of controls (see tables below).  You may\nalso put \"@interact(layout=...)\" to control the layout of controls.\nWithin the function, you may explicitly set the value of the\ncontrol corresponding to a variable foo to bar by typing\ninteract.foo = bar.\n\nType \"interact.controls.[tab]\" to get access to all of the\ncontrols.\n\nINPUT:\n\n* \"f\" -- function\n\n* \"width\" -- number, or string such as '80%', '300px', '20em'.\n\n* \"style\" -- CSS style string, which allows you to change the\n  border, background color, etc., of the interact.\n\n* \"update_args\" -- (default: None); list of strings, so that only\n  changing the corresponding controls causes the function to be re-\n  evaluated; changing other controls will not cause an update.\n\n* \"auto_update\" -- (default: True); if False, a button labeled\n  'Update' will appear which you can click on to re-evalute.\n\n* \"layout\" -- (default: one control per row) a list [row0, row1,\n  ...] of lists of tuples row0 = [(var_name, width, label), ...],\n  where the var_name's are strings, the widths must add up to at\n  most 12, and the label is optional.  This will layout all of the\n  controls and output using Twitter Bootstraps \"Fluid layout\", with\n  spans corresponding to the widths.   Use var_name='' to specify\n  where the output goes, if you don't want it to last.  You may\n  specify entries for controls that you will create later using\n  interact.var_name = foo.\n\nNOTES: The flicker and layout options above are only in SALVUS.\n   For backwards compatibility with the Sage notebook, if layout is\n   a dictionary (with keys 'top', 'bottom', 'left', 'right'), then\n   the appropriate layout will be rendered as it used to be in the\n   Sage notebook.\n\nOUTPUT:\n\n* creates an interactive control.\n\nThere are also some defaults that allow you to make controls\nautomatically without having to explicitly specify them.  E.g., you\ncan make \"x\" a continuous slider of values between \"u\" and \"v\" by\njust writing \"x=(u,v)\" in the argument list.\n\n* \"u\" - blank input_box\n\n* \"u=elt\" - input_box with \"default=element\", unless other rule\n  below\n\n* \"u=(umin,umax)\" - continuous slider (really 100 steps)\n\n* \"u=(umin,umax,du)\" - slider with step size \"du\"\n\n* \"u=list\" - buttons if \"len(list)\" at most 5; otherwise, drop\n  down\n\n* \"u=generator\" - a slider (up to 10000 steps)\n\n* \"u=bool\" - a checkbox\n\n* \"u=Color('blue')\" - a color selector; returns \"Color\" object\n\n* \"u=matrix\" - an \"input_grid\" with \"to_value\" set to\n  \"matrix.parent()\" and default values given by the matrix\n\n* \"u=(default, v)\" - \"v\" anything as above, with given \"default\"\n  value\n\n* \"u=(label, v)\" - \"v\" anything as above, with given \"label\" (a\n  string)\n\nEXAMPLES:\n\nThe layout option:\n\n   @interact(layout={'top': [['a', 'b']], 'left': [['c']],\n                     'bottom': [['d']], 'right':[['e']]})\n   def _(a=x^2, b=(0..20), c=100, d=x+1, e=sin(2)):\n       print(a+b+c+d+e)\n\nWe illustrate some features that are only in Salvus, not in the\nSage cell server or Sage notebook.\n\nYou can set the value of a control called foo to 100 using\ninteract.foo=100. For example:\n\n   @interact\n   def f(n=20, twice=None):\n       interact.twice = int(n)*2\n\nIn this example, we create and delete multiple controls depending\non properties of the input:\n\n   @interact\n   def f(n=20, **kwds):\n       print(kwds)\n       n = Integer(n)\n       if n % 2 == 1:\n           del interact.half\n       else:\n           interact.half = input_box(n/2, readonly=True)\n       if n.is_prime():\n           interact.is_prime = input_box('True', readonly=True)\n       else:\n           del interact.is_prime\n\nWe illustrate not automatically updating the function until a\nbutton is pressed:\n\n   @interact(auto_update=False)\n   def f(a=True, b=False):\n       print a, b\n\nYou can access the value of a control associated to a variable foo\nthat you create using interact.foo, and check whether there is a\ncontrol associated to a given variable name using hasattr:\n\n   @interact\n   def f():\n       if not hasattr(interact, 'foo'):\n           interact.foo = 'hello'\n       else:\n           print(interact.foo)\n\nAn indecisive interact:\n\n   @interact\n   def f(n=selector(['yes', 'no'])):\n       for i in range(5):\n           interact.n = i%2\n           sleep(.2)\n\nWe use the style option to make a holiday interact:\n\n   @interact(width=25,\n             style=\"background-color:lightgreen; border:5px dashed red;\")\n   def f(x=button('Merry ...',width=20)):\n       pass\n\nWe make a little box that can be dragged around, resized, and is\nupdated via a computation (in this case, counting primes):\n\n   @interact(width=30,\n       style=\"background-color:lightorange; position:absolute; z-index:1000; box-shadow : 8px 8px 4px #888;\")\n   def f(prime=text_control(label=\"Counting primes: \")):\n       salvus.javascript(\"cell.element.closest('.salvus-cell-output-interact').draggable().resizable()\")\n       p = 2\n       c = 1\n       while True:\n           interact.prime = '%s, %.2f'%(p, float(c)/p)\n           p = next_prime(p)\n           c += 1\n           sleep(.25)"}}︡{"done":true}︡
︠8277ffe5-aac2-4b69-a3a7-359af0f5f7a2︠









